package org.nl.acs.route.service;

import org.nl.acs.route.domain.RouteLoc;
import org.nl.acs.route.service.dto.RouteLocDto;
import org.nl.acs.route.service.dto.RouteLocQueryParam;
import org.nl.acs.common.base.CommonService;
import org.nl.acs.common.base.PageInfo;
import org.springframework.data.domain.Pageable;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
* @author jiaolm
* @date 2023-05-09
*/
public interface RouteLocService extends CommonService<RouteLoc>  {

    static final String CACHE_KEY = "routeLoc";

    /**
    * 查询数据分页
    * @param query 条件
    * @param pageable 分页参数
    * @return PageInfo<RouteLocDto>
    */
    PageInfo<RouteLocDto> queryAll(RouteLocQueryParam query, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param query 条件参数
    * @return List<RouteLocDto>
    */
    List<RouteLocDto> queryAll(RouteLocQueryParam query);

    RouteLoc getById(String id);
    RouteLocDto findById(String id);

    /**
     * 插入一条新数据。
     */
    int insert(RouteLocDto resources);
    int updateById(RouteLocDto resources);
    int removeById(String id);
    int removeByIds(Set<String> ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    // void download(List<RouteLocDto> all, HttpServletResponse response) throws IOException;

    /**
     * 查询数据分页
     *
     * @param whereJson 条件
     * @param page      分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(Map whereJson, Pageable page);

    /**
     * 查询所有数据不分页
     *
     * @param whereJson 条件参数
     * @return List<RouteLocDto>
     */
    List<RouteLocDto> queryAll(Map whereJson);

    /**
     * 根据ID查询
     *
     * @param ioc_uuid ID
     * @return RouteLoc
     */
//    RouteLocDto findById(String ioc_uuid);

    /**
     * 根据编码查询
     *
     * @param code code
     * @return RouteLoc
     */
//    RouteLocDto findByCode(String code);


    /**
     * 创建
     *
     * @param dto /
     */
    void create(RouteLocDto dto);

    /**
     * 编辑
     *
     * @param dto /
     */
    void update(RouteLocDto dto);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(String[] ids);

    /**
     * 导出数据
     *
     * @param dtos     待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<RouteLocDto> dtos, HttpServletResponse response) throws IOException;
}
